package org.mycompany.service.db.service;

import java.util.ArrayList;
import java.util.Collection;
import java.util.Date;
import java.util.List;

import javax.xml.bind.annotation.XmlAccessType;
import javax.xml.bind.annotation.XmlAccessorType;
import javax.xml.bind.annotation.XmlElement;
import javax.xml.bind.annotation.XmlType;

import org.apache.commons.lang.builder.EqualsBuilder;
import org.apache.commons.lang.builder.HashCodeBuilder;
import org.apache.commons.lang.builder.ToStringBuilder;
import org.apache.commons.lang.builder.ToStringStyle;

public class Concept_ {

	protected String id;
	protected Date creationDateTime;
	protected Concept_.Types types;
	protected String creator;

	/**
	 * Default no-arg constructor
	 * 
	 */
	public Concept_() {
		super();
	}

	/**
	 * Fully-initialising value constructor
	 * 
	 */
	public Concept_(final String id, final Date creationDateTime, final Concept_.Types types, final String creator) {
		this.id = id;
		this.creationDateTime = creationDateTime;
		this.types = types;
		this.creator = creator;
	}

	/**
	 * Gets the value of the id property.
	 * 
	 * @return possible object is {@link String }
	 * 
	 */
	public String getId() {
		return id;
	}

	/**
	 * Sets the value of the id property.
	 * 
	 * @param value
	 *            allowed object is {@link String }
	 * 
	 */
	public void setId(String value) {
		this.id = value;
	}

	/**
	 * Gets the value of the creationDateTime property.
	 * 
	 * @return possible object is {@link String }
	 * 
	 */
	public Date getCreationDateTime() {
		return creationDateTime;
	}

	/**
	 * Sets the value of the creationDateTime property.
	 * 
	 * @param value
	 *            allowed object is {@link String }
	 * 
	 */
	public void setCreationDateTime(Date value) {
		this.creationDateTime = value;
	}

	/**
	 * Gets the value of the types property.
	 * 
	 * @return possible object is {@link Concept_.Types }
	 * 
	 */
	public Concept_.Types getTypes() {
		return types;
	}

	/**
	 * Sets the value of the types property.
	 * 
	 * @param value
	 *            allowed object is {@link Concept_.Types }
	 * 
	 */
	public void setTypes(Concept_.Types value) {
		this.types = value;
	}

	/**
	 * Gets the value of the creator property.
	 * 
	 * @return possible object is {@link String }
	 * 
	 */
	public String getCreator() {
		return creator;
	}

	/**
	 * Sets the value of the creator property.
	 * 
	 * @param value
	 *            allowed object is {@link String }
	 * 
	 */
	public void setCreator(String value) {
		this.creator = value;
	}

	@Override
	public String toString() {
		return ToStringBuilder.reflectionToString(this, ToStringStyle.SIMPLE_STYLE);
	}

	@Override
	public boolean equals(Object that) {
		return EqualsBuilder.reflectionEquals(this, that);
	}

	@Override
	public int hashCode() {
		return HashCodeBuilder.reflectionHashCode(this);
	}

	public Concept_ withId(String value) {
		setId(value);
		return this;
	}

	public Concept_ withCreationDateTime(Date value) {
		setCreationDateTime(value);
		return this;
	}

	public Concept_ withTypes(Concept_.Types value) {
		setTypes(value);
		return this;
	}

	public Concept_ withCreator(String value) {
		setCreator(value);
		return this;
	}

	public List<ConceptType_> getTypesAsList() {
		if (types == null) {
			types = new Concept_.Types();
		}
		return types.getType();
	}

	/**
	 * <p>
	 * Java class for anonymous complex type.
	 * 
	 * <p>
	 * The following schema fragment specifies the expected content contained within this class.
	 * 
	 * <pre>
	 * &lt;complexType&gt;
	 *   &lt;complexContent&gt;
	 *     &lt;restriction base=&quot;{http://www.w3.org/2001/XMLSchema}anyType&quot;&gt;
	 *       &lt;sequence&gt;
	 *         &lt;element name=&quot;type&quot; type=&quot;{http://service.mycompany.org/}conceptType&quot; maxOccurs=&quot;unbounded&quot;/&gt;
	 *       &lt;/sequence&gt;
	 *     &lt;/restriction&gt;
	 *   &lt;/complexContent&gt;
	 * &lt;/complexType&gt;
	 * </pre>
	 * 
	 * 
	 */
	@XmlAccessorType(XmlAccessType.FIELD)
	@XmlType(name = "", propOrder = { "type" })
	public static class Types {

		@XmlElement(required = true)
		protected List<ConceptType_> type;

		/**
		 * Default no-arg constructor
		 * 
		 */
		public Types() {
			super();
		}

		/**
		 * Fully-initialising value constructor
		 * 
		 */
		public Types(final List<ConceptType_> type) {
			this.type = type;
		}

		/**
		 * Gets the value of the type property.
		 * 
		 * <p>
		 * This accessor method returns a reference to the live list, not a snapshot. Therefore any modification you
		 * make to the returned list will be present inside the JAXB object. This is why there is not a <CODE>set</CODE>
		 * method for the type property.
		 * 
		 * <p>
		 * For example, to add a new item, do as follows:
		 * 
		 * <pre>
		 * getType().add(newItem);
		 * </pre>
		 * 
		 * 
		 * <p>
		 * Objects of the following type(s) are allowed in the list {@link ConceptType_ }
		 * 
		 * 
		 */
		public List<ConceptType_> getType() {
			if (type == null) {
				type = new ArrayList<ConceptType_>();
			}
			return this.type;
		}

		@Override
		public String toString() {
			return ToStringBuilder.reflectionToString(this, ToStringStyle.SIMPLE_STYLE);
		}

		@Override
		public boolean equals(Object that) {
			return EqualsBuilder.reflectionEquals(this, that);
		}

		@Override
		public int hashCode() {
			return HashCodeBuilder.reflectionHashCode(this);
		}

		public Concept_.Types withType(ConceptType_... values) {
			if (values != null) {
				for (ConceptType_ value : values) {
					getType().add(value);
				}
			}
			return this;
		}

		public Concept_.Types withType(Collection<ConceptType_> values) {
			if (values != null) {
				getType().addAll(values);
			}
			return this;
		}

	}

}
